#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_dJIK40x40x40TT0x0x0_aX_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=40, NB=40, KB=40, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=4, ku=40, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const double *stM = A + (((lda) << 5)+((lda) << 3));
   const double *stN = B + 40;
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 40
   const int incAm = ((((lda) << 1)) - 40), incAn = -(((lda) << 5)+((lda) << 3));
   const int incBk = (ldb), incBm = -(((ldb) << 5)+((ldb) << 3));
   #define incBn 4
   const int incAk0 = ((incAk) / 40);
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 2)) - 40;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const double *pA0=A, *pA1=pA0+(lda);
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0, rB1, rB2, rB3;
   register double m0, m1, m2, m3;
   register double rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[1];
         rC1_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC1_1 = pC1[1];
         rC1_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
         rC1_2 = pC2[1];
         rC1_2 *= rA0;
         rC0_3 = *pC3;
         rC0_3 *= rA0;
         rC1_3 = pC3[1];
         rC1_3 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         m0 = rA0 * rB0;
         rB1 = pB0[1];
         m1 = rA1 * rB0;
         rB2 = pB0[2];
         m2 = rA0 * rB1;
         rB3 = pB0[3];
         m3 = rA1 * rB1;

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[1];
         rB0 = *pB0;
         rA1 = pA1[1];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[2];
         rB0 = *pB0;
         rA1 = pA1[2];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[3];
         rB0 = *pB0;
         rA1 = pA1[3];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[4];
         rB0 = *pB0;
         rA1 = pA1[4];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[5];
         rB0 = *pB0;
         rA1 = pA1[5];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[6];
         rB0 = *pB0;
         rA1 = pA1[6];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[7];
         rB0 = *pB0;
         rA1 = pA1[7];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[8];
         rB0 = *pB0;
         rA1 = pA1[8];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[9];
         rB0 = *pB0;
         rA1 = pA1[9];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[10];
         rB0 = *pB0;
         rA1 = pA1[10];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[11];
         rB0 = *pB0;
         rA1 = pA1[11];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[12];
         rB0 = *pB0;
         rA1 = pA1[12];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[13];
         rB0 = *pB0;
         rA1 = pA1[13];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[14];
         rB0 = *pB0;
         rA1 = pA1[14];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[15];
         rB0 = *pB0;
         rA1 = pA1[15];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[16];
         rB0 = *pB0;
         rA1 = pA1[16];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[17];
         rB0 = *pB0;
         rA1 = pA1[17];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[18];
         rB0 = *pB0;
         rA1 = pA1[18];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[19];
         rB0 = *pB0;
         rA1 = pA1[19];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[20];
         rB0 = *pB0;
         rA1 = pA1[20];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[21];
         rB0 = *pB0;
         rA1 = pA1[21];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[22];
         rB0 = *pB0;
         rA1 = pA1[22];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[23];
         rB0 = *pB0;
         rA1 = pA1[23];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[24];
         rB0 = *pB0;
         rA1 = pA1[24];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[25];
         rB0 = *pB0;
         rA1 = pA1[25];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[26];
         rB0 = *pB0;
         rA1 = pA1[26];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[27];
         rB0 = *pB0;
         rA1 = pA1[27];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[28];
         rB0 = *pB0;
         rA1 = pA1[28];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[29];
         rB0 = *pB0;
         rA1 = pA1[29];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[30];
         rB0 = *pB0;
         rA1 = pA1[30];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[31];
         rB0 = *pB0;
         rA1 = pA1[31];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[32];
         rB0 = *pB0;
         rA1 = pA1[32];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[33];
         rB0 = *pB0;
         rA1 = pA1[33];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[34];
         rB0 = *pB0;
         rA1 = pA1[34];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[35];
         rB0 = *pB0;
         rA1 = pA1[35];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[36];
         rB0 = *pB0;
         rA1 = pA1[36];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[37];
         rB0 = *pB0;
         rA1 = pA1[37];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[38];
         rB0 = *pB0;
         rA1 = pA1[38];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rA0 = pA0[39];
         rB0 = *pB0;
         rA1 = pA1[39];
         rB1 = pB0[1];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rB2 = pB0[2];
         rC1_2 += m1;
         m1 = rA1 * rB0;
         rB3 = pB0[3];
         rC0_3 += m2;
         m2 = rA0 * rB1;
         rC1_3 += m3;
         m3 = rA1 * rB1;
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC1_0 += m1;
         m1 = rA1 * rB2;
         rC0_1 += m2;
         m2 = rA0 * rB3;
         rC1_1 += m3;
         m3 = rA1 * rB3;
         pB0 += incBk;
         rC0_2 += m0;
         rC1_2 += m1;
         rC0_3 += m2;
         rC1_3 += m3;
         pA0 += incAk;
         pA1 += incAk;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC1_2 *= rB0;
         rC1_3 *= rB0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
